/* editor.c: Code to call the user's preferred editor.
 *
 * $Id: editor.c,v 1.5 2002/10/28 23:36:55 andy Exp $
 *
 * Copyright (C) 2002 Andy Goth <unununium@openverse.com>
 * For more information visit http://ioioio.net/devel/install-log/
 * 
 * This program is free software; you can redistribute it and/or modify it
 * under the terms of the GNU General Public License as published by the Free
 * Software Foundation; either version 2 of the License, or (at your option)
 * any later version.
 * 
 * This program is distributed in the hope that it will be useful, but WITHOUT
 * ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or
 * FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License for
 * more details.
 * 
 * You should have received a copy of the GNU General Public License along with
 * this program; if not, write to the Free Software Foundation, Inc., 59 Temple
 * Place - Suite 330, Boston, MA  02111-1307, USA. */

#include <errno.h>
#include <stdio.h>
#include <stdlib.h>
#include <sys/types.h>
#include <sys/wait.h>
#include <unistd.h>
#include "install-log.h"

static void edit_file(char* filename);

/* Open the database file with the user-specified editor.  'envp' is the
 * program's environment. */
void edit_database(void)
{
	char* filename = safe_sprintf(NULL, NULL, "%s/%s", logdir, package);
	collapse(filename, '/');
	edit_file(filename);
	free(filename);
}

/* Open 'filename' using the user-specified editor. */
static void edit_file(char* filename)
{
	char* command = safe_sprintf(NULL, NULL, "%s %s", editor, filename);
	switch (system(command)) {
	case -1:
	case 127:
		alert("system(%s): %s\n", command, strerror(errno));
	}
	free(command);
}

/* EOF */
